// gate-level 2-to-4 line decoder with enable (test bench)
//
// Ryan Clarke
// rfclarke@alum.wpi.edu

`timescale 1 ns / 10 ps

module binary_decoder_test;
    // test inputs and outputs
    reg en;
    reg [1:0] a;
    wire [3:0] d;
    
    // unit under test
    binary_decoder uut(.en(en), .a(a), .d(d));
    
    // run tests for all iterations of en and a, 250 ns per test
    initial begin
        en = 1'b0;
        a = 2'b00;
        # 250;

        en = 1'b0;
        a = 2'b01;
        # 250;

        en = 1'b0;
        a = 2'b10;
        # 250;

        en = 1'b0;
        a = 2'b11;
        # 250;
        
        en = 1'b1;
        a = 2'b00;
        # 250;

        en = 1'b1;
        a = 2'b01;
        # 250;

        en = 1'b1;
        a = 2'b10;
        # 250;

        en = 1'b1;
        a = 2'b11;
        # 250;
        
        $stop;
    end

endmodule
